import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

export default function listDataRemoveItem(removedItem) {
  return function callback(result) {
    switch (result.state) {
      case 'error-initial':
      case 'error-more':
      case 'error-sort':
      case 'fetching-initial':
        {
          return result;
        }

      default:
        {
          var index = result.data.items.findIndex(function (item) {
            return item.id === removedItem.id;
          });

          if (index === -1) {
            return result;
          }

          var items = [].concat(_toConsumableArray(result.data.items.slice(0, index)), _toConsumableArray(result.data.items.slice(index + 1)));
          return _objectSpread(_objectSpread({}, result), {}, {
            data: _objectSpread(_objectSpread({}, result.data), {}, {
              items: items,
              totalCount: result.data.totalCount - 1
            })
          });
        }
    }
  };
}
//# sourceMappingURL=listDataRemoveItem.js.map